CREATE OR REPLACE PROCEDURE COMPOSICAO_RECEITA_PREVSVCOC(
P_NRRECPREVSVCOC IN FLOAT
)
AS
V_NRPRODUTO VARCHAR2(20);
V_NRRECEITA VARCHAR2(20);

V_QTREND FLOAT;
BEGIN
   FOR C_COMPOSICAO_REC IN
   (
   SELECT R.NRPREVSVCOC, R.NRRECPREVSVCOC, R.NRSUBGRUPREVSVCOC, R.NRSERVPREVSVCOC,
          NVL(R.CDRECEITAORI, R.CDRECEITA) AS CDRECEITAORI, R.CDRECEITA AS CDRECEITAPAI,
          R.CDSETOR, S.CDSETOR AS CDSETORSUBREC,
          PT.CDPRODUTO, 
          ROUND(C.QTINSUMO * (R.QTRECPREVSVCOC / R.QTRENDRECPREVSVCOC), 3) AS QUANTIDADE, -- Insumos necessrios para qtde/rend receitas
          CASE WHEN PT.IDPRODCOMISS IS NULL THEN 'P' ELSE 'R' END AS TIPO 
     FROM RECPREVSVCOC R          
          INNER JOIN (SELECT CDPRODUTO, MAX(CDESPEPROD) AS CDESPEPROD
                       FROM ESPEPROD
                      WHERE (CDMANCIA IS NULL OR IDTPMANUAL IS NULL)
                      GROUP BY CDPRODUTO) E ON E.CDPRODUTO = R.CDRECEITA
          INNER JOIN (SELECT CDPRODUTO, CDESPEPROD, MAX(CDTIPOCOMP) CDTIPOCOMP
                        FROM TCOMPPRO
                       GROUP BY CDPRODUTO, CDESPEPROD) T ON T.CDPRODUTO = E.CDPRODUTO AND
                                                            T.CDESPEPROD = E.CDESPEPROD
          INNER JOIN COMPPROD C ON C.CDPRODUTO = E.CDPRODUTO AND
                                  C.CDESPEPROD = E.CDESPEPROD AND
                                  C.CDTIPOCOMP = T.CDTIPOCOMP
          INNER JOIN PRODUTO PT ON PT.CDPRODUTO = C.CDPRODINSUMO
          LEFT JOIN SETOR S ON S.CDSETOR = PT.CDSETOR
    WHERE R.NRRECPREVSVCOC = P_NRRECPREVSVCOC
   ) LOOP
      IF C_COMPOSICAO_REC.TIPO = 'P' THEN
        IF C_COMPOSICAO_REC.QUANTIDADE > 0 THEN
           NOVO_CODIGO_SC('PRODPREVSVCOC',V_NRPRODUTO);
           INSERT INTO PRODPREVSVCOC
           (NRPRODPREVSVCOC , NRSUBGRUPREVSVCOC, NRPREVSVCOC,
            NRRECPREVSVCOC, CDRECEITA, CDPRODUTO,
            CDSETOR, QTPRODPREVSVCOC, NRSERVPREVSVCOC)
           VALUES
           (TO_NUMBER(V_NRPRODUTO), C_COMPOSICAO_REC.NRSUBGRUPREVSVCOC, C_COMPOSICAO_REC.NRPREVSVCOC,
            C_COMPOSICAO_REC.NRRECPREVSVCOC, C_COMPOSICAO_REC.CDRECEITAPAI, C_COMPOSICAO_REC.CDPRODUTO,
            C_COMPOSICAO_REC.CDSETOR,C_COMPOSICAO_REC.QUANTIDADE, C_COMPOSICAO_REC.NRSERVPREVSVCOC);      
        END IF;
      ELSE
         SELECT MAX(QTREND)
           INTO V_QTREND
           FROM
         (SELECT NVL(QTRENDRECLOC, 0) AS QTREND
            FROM RENDLOCAL
            WHERE CDRECEITA = C_COMPOSICAO_REC.CDPRODUTO
         UNION
         SELECT NVL(QTRENDRECPAD, 0) AS QTREND
           FROM RENDPADRAO
          WHERE CDRECEITA = C_COMPOSICAO_REC.CDPRODUTO);
        
         IF V_QTREND > 0 AND C_COMPOSICAO_REC.QUANTIDADE > 0 THEN
            NOVO_CODIGO_SC('RECPREVSVCOC',V_NRRECEITA);
            INSERT INTO RECPREVSVCOC
            (NRRECPREVSVCOC, NRSUBGRUPREVSVCOC, NRPREVSVCOC,
             NRRECPAI, CDRECEITA, CDRECEITAORI,
             CDRECEITAPAI,CDSETOR, QTRECPREVSVCOC,
             QTRENDRECPREVSVCOC, NRSERVPREVSVCOC)
            VALUES
            (TO_NUMBER(V_NRRECEITA), C_COMPOSICAO_REC.NRSUBGRUPREVSVCOC, C_COMPOSICAO_REC.NRPREVSVCOC,
             C_COMPOSICAO_REC.NRRECPREVSVCOC, C_COMPOSICAO_REC.CDPRODUTO, C_COMPOSICAO_REC.CDRECEITAORI,
             C_COMPOSICAO_REC.CDRECEITAPAI, C_COMPOSICAO_REC.CDSETORSUBREC, C_COMPOSICAO_REC.QUANTIDADE,
             V_QTREND, C_COMPOSICAO_REC.NRSERVPREVSVCOC);
            
            -- Insere composio da subreceita
            COMPOSICAO_RECEITA_PREVSVCOC(TO_NUMBER(V_NRRECEITA));
         END IF;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('COMPOSICAO_RECEITA_PREVSVCOC','5.85.xxx'); END;
/