/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: APURAC_MANDATO

DESCRIO:
   PROCEDIMENTO PARA APURAO DE FATURAMENTO DE CLIENTES EM FILIAIS
   QUE UTILIZAM O TIPO DE CONTRATO MANDATO.

CRIAO:
11/04/2001 - DISNEI H. DE MOURA

VERSO P/ SQLSERVER :
04/01/2002 - ALESSNADRA CRISTINA

--   RAISERRO('TESTE',16,1);
*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'APURAC_MANDATO' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE APURAC_MANDATO
GO

CREATE PROCEDURE APURAC_MANDATO(
      @P_CDFILIAPUR  VARCHAR(04),
      @P_CDFILIPROC  VARCHAR(04),
      @P_CDCLIENTE   VARCHAR(21),
      @P_DATAINI     DATETIME,
      @P_DATAFIM     DATETIME,
      @P_NRAPURACFAT VARCHAR(10),
      @P_NRLANCTONF  VARCHAR(10),
      @P_IDNFCOMPRA  VARCHAR(01),
      @P_DTINIAPUR   DATETIME = NULL,
      @P_DTFINAPUR   DATETIME = NULL,
      @P_VRNOTACRED  DOUBLE PRECISION = 0,
      @P_VRBASENFCMP DOUBLE PRECISION = 0,
      @P_DATAPROC    DATETIME
) AS

    DECLARE  @V_CDEMPRATAC    VARCHAR(02);
    DECLARE  @V_CDINSCATAC    VARCHAR(16);
    DECLARE  @V_CDINSCMUNI    VARCHAR(16);
    DECLARE  @V_CDEMPROPER    VARCHAR(02);
    DECLARE  @V_CDSERIE       VARCHAR(05);
    DECLARE  @V_CDSERIEDESP   VARCHAR(05);
    DECLARE  @V_CDIMPOSTO     VARCHAR(02);
    DECLARE  @V_CDFILIAPUR    VARCHAR(04);
    DECLARE  @V_NRLANCTONF    VARCHAR(10);
    DECLARE  @V_NRINSJURNF    VARCHAR(20);
    DECLARE  @V_VRNOTAFISC    VARCHAR(16);
    DECLARE  @V_VRDOTACAO     VARCHAR(16);
    DECLARE  @V_NRLANCESTQ    VARCHAR(10);
    DECLARE  @V_CDPRGENEREV   VARCHAR(10);
    DECLARE  @V_NMPRGENEREV   VARCHAR(50);
    DECLARE  @V_DSAJUCTREC    VARCHAR(20);
    DECLARE  @V_ENCARGO       VARCHAR(02);
    DECLARE  @V_LANCNFILIAL   VARCHAR(40);
    DECLARE  @V_NVPRGENEREV   VARCHAR(20);
    DECLARE  @V_DSPRPRESERV   VARCHAR(40);
    DECLARE  @V_VERIGRUPDES   VARCHAR(02);
    DECLARE  @V_IDTAXAADM     VARCHAR(01);
    DECLARE  @V_IDCALCCOMPR   VARCHAR(01);
    DECLARE  @V_IDRECUIMPOS   VARCHAR(01);
    DECLARE  @V_DESCDOTACAO   VARCHAR(01);
    DECLARE  @V_CDAJUSTPADR   VARCHAR(02);
    DECLARE  @V_CDENCREDITO   VARCHAR(02);
    DECLARE  @V_CDENCDEBITO   VARCHAR(02);
    DECLARE  @V_IDCONCMPDES   VARCHAR(01);
    DECLARE  @V_CDPROREECMP   VARCHAR(10);
    DECLARE  @V_CDPRODDOTA    VARCHAR(10);
    DECLARE  @V_CDPRODCREDI   VARCHAR(10);
    DECLARE  @V_IDAVISOCRED   VARCHAR(01);
    DECLARE  @V_IDPERCDOTA1   VARCHAR(01);
    DECLARE  @V_IDPERCDOTA2   VARCHAR(01);
    DECLARE  @V_IDPERCDOTA3   VARCHAR(01);
    DECLARE  @V_IDPERCDOTA4   VARCHAR(01);
    DECLARE  @V_CDSERIEDOT    VARCHAR(05);
    DECLARE  @V_CDARVPROD     VARCHAR(20);
    DECLARE  @V_CDPRESTSERV   VARCHAR(10);
    DECLARE  @V_VRPERCDOT1    NUMERIC;
    DECLARE  @V_VRPERCDOT2    NUMERIC;
    DECLARE  @V_VRPERCDOT3    NUMERIC;
    DECLARE  @V_VRPERCDOT4    NUMERIC;
    DECLARE  @V_VRPERCDOT5    NUMERIC;
    DECLARE  @V_VRPERCDOT6    NUMERIC;
    DECLARE  @V_VRBRUTITEM    NUMERIC(16,5);
    DECLARE  @V_VRIMPOSTOIT   NUMERIC(16,5);
    DECLARE  @V_VRBRUTDESP    NUMERIC(16,5);
    DECLARE  @V_VRTAXAADM     NUMERIC;
    DECLARE  @V_VRPCTXADM     NUMERIC;
    DECLARE  @V_VRLIQUFATU    NUMERIC;
    DECLARE  @V_PRXDESPESA    NUMERIC;
    DECLARE  @V_VRIMPODEBI    NUMERIC;
    DECLARE  @V_VRDEBITO      NUMERIC(16,5);
    DECLARE  @V_VRPERCDESP    NUMERIC(16,5);
    DECLARE  @V_CDNIVELPROD   INTEGER;
    DECLARE  @V_NRSEQVENREC   VARCHAR(02);
    DECLARE  @V_VRATUAREC     DOUBLE PRECISION;
    DECLARE  @V_NRPARCELAREC  VARCHAR(02);
    DECLARE  @V_NRITENSNOTA   NUMERIC;
/*VARIVEIS DO CURSOR C_DELETANF*/
    DECLARE  @V_CDFILI        VARCHAR(04);
    DECLARE  @V_NRLANCTO      VARCHAR(10);

/*VARIVEIS DO CURSOR C_DESPADMFATUR*/
    DECLARE @VRTAXADMFATU     NUMERIC;
    DECLARE @CDFILIAL         VARCHAR(04);
    DECLARE @CDDESPADMFAT     VARCHAR(02)
    DECLARE @DTLANCDESFAT     DATETIME;
    DECLARE @VRLANCDESFAT     NUMERIC;
    DECLARE @CDGRUPOFATUR     VARCHAR(02);
    DECLARE @CDPRODUTO        VARCHAR(10);
    DECLARE @DSDESPADMFAT     VARCHAR(40);
    DECLARE @V_DTINIAPURAC    DATETIME;
    DECLARE @V_DTFIMAPURAC    DATETIME;

    DECLARE @V_PRXMRDP     NUMERIC;
    DECLARE @V_NRPRACMRDP  NUMERIC;
    DECLARE @V_NUMITENS    NUMERIC;

    DECLARE @V_IDTXADMPROD  VARCHAR(01);
    DECLARE @V_IDNFPRODREV  VARCHAR(01);
    DECLARE @V_IDGEROUNF    VARCHAR(01);
    DECLARE @V_GERANF       VARCHAR(01);
    DECLARE @V_LANCAMENTO   VARCHAR(20);
    DECLARE @V_PAISORIG     VARCHAR(04);
    DECLARE @V_ESTAORIG     VARCHAR(02);
    DECLARE @V_MUNIORIG     VARCHAR(04);
    DECLARE @V_PAISDEST     VARCHAR(04);
    DECLARE @V_ESTADEST     VARCHAR(02);
    DECLARE @V_IDENDCFOP    VARCHAR(01);
    DECLARE @V_IDENDEMIS    VARCHAR(01);
    DECLARE @V_CDEMPRESA    VARCHAR(02);
    DECLARE @V_CDINSCESTA   VARCHAR(16);
    DECLARE @V_CDGRUPOFISC  VARCHAR(03);

    DECLARE @V_MAXITENSNF   NUMERIC;
    DECLARE @V_NRITEM       NUMERIC;
    DECLARE @V_SOMAALQIMP   NUMERIC;
    DECLARE @V_VRCUSTOMED   NUMERIC;
    DECLARE @V_VRALIQUTMP   NUMERIC;
    DECLARE @V_VRICMS       NUMERIC;
    DECLARE @V_VRLIQUIDO    NUMERIC;
    DECLARE @V_IDPERCDOTA5  VARCHAR(01);
    DECLARE @V_IDPERCDOTA6  VARCHAR(01);


    DECLARE @V_SERIE      VARCHAR(5);
    DECLARE @V_INSCESTA   VARCHAR(16);
    DECLARE @V_INSCMUNI   VARCHAR(16);
    DECLARE @V_NOVOCODIGO VARCHAR;

    /*VARIVEIS DO CURSOR C_ITEMNOTA*/

    DECLARE  @V_CDPRODUTO    VARCHAR(10);
    DECLARE  @V_VRTXADMPROD  NUMERIC;
    DECLARE  @V_CDPRODESTO   VARCHAR(10);
    DECLARE  @V_CDTIPOOPER   VARCHAR(02);
    DECLARE  @V_VRFATOCONV   NUMERIC;
    DECLARE  @V_NMPRODUTO    VARCHAR(50);
    DECLARE  @V_NMPRESTSERV  VARCHAR(50);
    DECLARE  @V_IDFATPRODCLI VARCHAR(01);
    DECLARE  @V_CDFILIAL     VARCHAR(04);
    DECLARE  @V_NRLANCTOIT   VARCHAR(10);
    DECLARE  @V_VRBRUTITEMIT NUMERIC;
    DECLARE  @V_VRIMPOSTO    NUMERIC;
    DECLARE  @V_QTITEMPROD   NUMERIC;
    DECLARE  @V_VRDICMPCRE   NUMERIC;
    DECLARE  @V_VRITEMNOTA   NUMERIC;
    DECLARE  @V_CUSTO        NUMERIC;
    DECLARE  @V_FILIAL       VARCHAR(04);
    DECLARE  @V_LANCTONF     VARCHAR(20);
    DECLARE  @V_TIPOOPER     VARCHAR(02);
    DECLARE  @V_DESCIT       NUMERIC;
    DECLARE  @V_QTDESCIT     NUMERIC;
    DECLARE  @V_VRSAIDA      NUMERIC;
    DECLARE  @V_VRIMPOSAID   NUMERIC;
    DECLARE  @V_PRODUTOS     VARCHAR(10);
    DECLARE  @V_VRTRANSF     NUMERIC;
    DECLARE  @V_VRIMPOTRANSF NUMERIC;
    DECLARE  @V_QTDESCIT1    NUMERIC;
    DECLARE  @V_VRSALDODEV   NUMERIC;
    DECLARE  @V_VRTOTADESP   NUMERIC;
    DECLARE  @V_VRIMPCORPO   NUMERIC;
    DECLARE  @V_VRTXFATNIV   NUMERIC;
    DECLARE  @V_VRDESCNFCMP  NUMERIC;
    DECLARE  @V_VRRECUIMCMP  NUMERIC;
    DECLARE  @V_VRRECUIMDES  NUMERIC;
    DECLARE  @V_VRRECUIMDET  NUMERIC;
    DECLARE  @V_VRTOTACMP    NUMERIC;
    DECLARE  @V_VRTOTCMPSTX  NUMERIC;
    DECLARE  @V_VRTOTCMPCTX  NUMERIC;
    DECLARE  @V_VRSALDODOT   NUMERIC;
    DECLARE  @V_VRTOTDESSTX  NUMERIC;
    DECLARE  @V_VRTOTDESCTX  NUMERIC;
    DECLARE  @V_VRDOTPURPASS NUMERIC;
    DECLARE  @V_TOTAL        NUMERIC;


BEGIN
   SET  @V_VRNOTAFISC   = 0;
   SET  @V_GERANF       = 'S';
   SET  @V_IDGEROUNF    = 'N';
   SET  @V_NRITEM       = 0;
   SET  @V_SOMAALQIMP   = 0;
   SET  @V_DESCIT       = 0;
   SET  @V_VRSAIDA      = 0;
   SET  @V_VRIMPOSAID   = 0;
   SET  @V_VRBRUTDESP   = 0;
   SET  @V_VRDEBITO     = 0;
   SET  @V_VRDICMPCRE   = 0;
   SET  @V_VRLIQUIDO    = 0;
   SET  @V_VRSALDODEV   = 0;
   SET  @V_VRTOTADESP   = 0;
   SET  @V_VRIMPCORPO   = 0;
   SET  @V_VRTXFATNIV   = 0;
   SET  @V_VRDESCNFCMP  = 0;
   SET  @V_VRRECUIMCMP  = 0;
   SET  @V_VRRECUIMDES  = 0;
   SET  @V_VRRECUIMDET  = 0;
   SET  @V_VRTOTACMP    = 0;
   SET  @V_VRTOTCMPSTX  = 0;
   SET  @V_VRTOTCMPCTX  = 0;
   SET  @V_VRSALDODOT   = 0;
   SET  @V_VRTOTDESSTX  = 0;
   SET  @V_VRTOTDESCTX  = 0;
   SET  @V_VRDOTPURPASS = 0;
   SET  @V_VRLIQUFATU   = 0;
   SET  @V_VRTOTCMPSTX  = 0;

   /* FILIAL QUE EST SENDO APURADA (P_FILIAL = FILIPROC)*/
   SELECT @V_CDFILIAPUR = MAX(CDFILIAPUR), @V_DTINIAPURAC = MAX(DTINIAPURAC)
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = @P_CDFILIPROC   AND
         NRAPURACFAT = @P_NRAPURACFAT;

   SELECT @V_DTINIAPURAC = MAX(DTINIAPURAC), @V_DTFIMAPURAC = MAX(DTFIMAPURAC)
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = @V_CDFILIAPUR   AND
         DTINIAPURAC < @V_DTINIAPURAC;


   SELECT @V_VRPCTXADM   = CONVERT(NUMERIC,ISNULL(MAX(SUBSTRING(PF.DSPARAMFATFI,31,6)), 0)), /*PERCENTUAL DE COMPRAS/REVENDA*/
          @V_CDEMPRATAC  = MAX(SUBSTRING(PF.DSPARAMFATFI,39,2)),           /*EMPRESA ATACADISTA*/
          @V_CDEMPROPER  = MAX(SUBSTRING(PF.DSPARAMFATFI,41,2)),           /*EMPRESA OPERACIONAL*/
          @V_IDTAXAADM   = MAX(SUBSTRING(PF.DSPARAMFATFI,43,1)),           /*TAXA DE ADMINISTRACAO*/
          @V_DSPRPRESERV = MAX(SUBSTRING(PG.DSPARAMFATGE,22,40)),          /*DESCRICAO PARA NOTA FISCAL*/
          @V_CDPRGENEREV = RTRIM(MAX(SUBSTRING(PG.DSPARAMFATGE,73,10))),   /*CODIGO DA PRODUTO PARA REVENDA*/
          @V_NVPRGENEREV = RTRIM(MAX(SUBSTRING(PG.DSPARAMFATGE,085,20))),  /* NVEL DOS PRODUTOS A SEREM GERADOS*/
          @V_IDCALCCOMPR = MAX(SUBSTRING(PF.DSPARAMFATFI,49,1)),           /*CALCULO VALOR TOTAL DE COMPRAS*/
          @V_IDRECUIMPOS = MAX(SUBSTRING(PF.DSPARAMFATFI,37,1)),           /*RECUPERAO DE IMPOSTOS*/
          @V_DESCDOTACAO = MAX(SUBSTRING(PF.DSPARAMFATFI,56,1)),           /*DESCONTO DE DOTAO*/
          @V_CDAJUSTPADR = MAX(SUBSTRING(PF.DSPARAMFATFI,57,2)),           /*AJUSTE PADRAO*/
          @V_CDENCDEBITO = MAX(SUBSTRING(PF.DSPARAMFATFI,59,2)),           /*ENCARGO DEBITO*/
          @V_CDENCREDITO = MAX(SUBSTRING(PF.DSPARAMFATFI,61,2)),           /*ENCARGO CREDITO*/
          @V_VRPERCDESP  = MAX(SUBSTRING(PF.DSPARAMFATFI,63,6)),           /*PERCENTUAL DE DESPESAS*/
          @V_IDTXADMPROD = MAX(SUBSTRING(PF.DSPARAMFATFI,69,1)),           /*TAXA DE ADM POR PRODUTO*/
          @V_IDNFPRODREV = MAX(SUBSTRING(PG.DSPARAMFATGE,155,1)),          /*GERA NF DE PRODUTO PARA REVENDA*/
          @V_CDTIPOOPER  = MAX(SUBSTRING(PF.DSPARAMFATFI,70,2)),            /*TIPO DE OPERACAO  */
          @V_IDCONCMPDES = MAX(SUBSTRING(PF.DSPARAMFATFI,72,1)),            /*IDENTIFICADOR DE PARA DE NF DE DESPESA E COMPREAS CONSOLIDADA*/
          @V_CDPROREECMP = RTRIM(MAX(SUBSTRING(PF.DSPARAMFATFI,73,10))), /*PRODUTO PARA REEMBOLSO DE COMPRAS*/
          @V_CDPRODDOTA  = RTRIM(MAX(SUBSTRING(PF.DSPARAMFATFI,83,10))), /*PRODUTO PARA AVISO DE DEBITO (DOTACAO)*/
          @V_CDPRODCREDI = RTRIM(MAX(SUBSTRING(PF.DSPARAMFATFI,147,10))), /*PRODUTO PARA AVISO DE CREDITO*/
          @V_IDAVISOCRED = MAX(SUBSTRING(PF.DSPARAMFATFI,93,01)),                       /*IDENTIFICADOR PARA VERIFICAR A GERACAO DE AVISO OU NF DE CREDITO*/
          @V_IDPERCDOTA1 = MAX(SUBSTRING(PF.DSPARAMFATFI,96,01)),                      /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO UM*/
          @V_VRPERCDOT1  = CONVERT(NUMERIC, ISNULL(MAX(REPLACE(SUBSTRING(PF.DSPARAMFATFI,97,06),NULL,'')), 0)),   /*PERCENTUAL PARA CALCUL0 DA DOTAAO UM*/
          @V_IDPERCDOTA2 = MAX(SUBSTRING(PF.DSPARAMFATFI,103,01)),                                       /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO DOIS*/
          @V_VRPERCDOT2  = CONVERT(NUMERIC, ISNULL(MAX(REPLACE(SUBSTRING(PF.DSPARAMFATFI,104,06),NULL,'')),0)), /*PERCENTUAL PARA CALCUL0 DA DOTAAO DOIS*/
          @V_IDPERCDOTA3 = MAX(SUBSTRING(PF.DSPARAMFATFI,110,01)),                 /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO TRES*/
          @V_VRPERCDOT3  = CONVERT(NUMERIC, ISNULL(MAX(REPLACE(SUBSTRING(PF.DSPARAMFATFI,111,06),NULL,'')),0)),       /*PERCENTUAL PARA CALCUL0 DA DOTAAO TRES*/
          @V_IDPERCDOTA4 = MAX(SUBSTRING(PF.DSPARAMFATFI,117,01)),                        /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO QUATRO*/
          @V_VRPERCDOT4  = CONVERT(NUMERIC, ISNULL(MAX(REPLACE(SUBSTRING(PF.DSPARAMFATFI,118,06),NULL,'')),0)),     /*PERCENTUAL PARA CALCUL0 DA DOTAAO QUATRO*/
          @V_IDPERCDOTA5  = MAX(SUBSTRING(PF.DSPARAMFATFI,124,01)),                      /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO CINCO*/
          @V_VRPERCDOT5  = CONVERT(NUMERIC, ISNULL(MAX(REPLACE(SUBSTRING(PF.DSPARAMFATFI,125,06),NULL,'')),0)),   /*PERCENTUAL PARA CALCUL0 DA DOTAAO CINCO*/
          @V_IDPERCDOTA6 = MAX(SUBSTRING(PF.DSPARAMFATFI,131,01)),                    /*IDENTIFICADOR PARA CALCUL0 DA DOTAAO SEIS*/
          @V_VRPERCDOT6  = CONVERT(NUMERIC, ISNULL(MAX(REPLACE(SUBSTRING(PF.DSPARAMFATFI,132,15),NULL,'')),0)), /*VALOR PARA CALCUL0 DA DOTAAO SEIS*/
          @V_CDSERIEDOT  = MAX(SUBSTRING(PF.DSPARAMFATFI,157,05)),                  /*SRIE PARA GERAO DE AVISO DEBITO/CREDITO */
          @V_CDPRESTSERV = RTRIM(MAX(SUBSTRING(PG.DSPARAMFATGE,156,10)))                  /*PRODUTO PARA PRESTAO DE SERVIOS*/

   FROM PARAMFILIAL PF, PARAMGERAL PG
   WHERE PF.CDFILIAL = @V_CDFILIAPUR;

   SET @V_VRPCTXADM   = @V_VRPCTXADM/1000;
   SET @V_VRPERCDESP  = @V_VRPERCDESP/1000;

   SET @V_VRPERCDOT1 = @V_VRPERCDOT1/100;
   SET @V_VRPERCDOT2 = @V_VRPERCDOT2/100;
   SET @V_VRPERCDOT3 = @V_VRPERCDOT3/100;
   SET @V_VRPERCDOT4 = @V_VRPERCDOT4/100;
   SET @V_VRPERCDOT5 = @V_VRPERCDOT5/100;

   IF (@V_CDTIPOOPER IS NULL) OR (@V_CDTIPOOPER = '  ') BEGIN
      SET @V_CDTIPOOPER = '01';
   END;

   IF @V_IDCONCMPDES IS NULL BEGIN
      SET @V_IDCONCMPDES = 'N';
   END;

   IF (@V_CDPRODDOTA IS NULL) OR (@V_CDPRODDOTA = '     ') BEGIN
      SET @V_CDPRODDOTA = NULL;
   END;

   IF (@V_CDAJUSTPADR IS NULL) OR (@V_CDAJUSTPADR = '  ') BEGIN
      SET @V_CDAJUSTPADR = NULL;
   END;

   SELECT @V_NMPRGENEREV = MAX(NMPRODUTO)
   FROM PRODUTO
   WHERE CDPRODUTO  =  @V_CDPRGENEREV;

   SELECT @V_CDNIVELPROD = DATALENGTH(MAX(CDARVPROD))
   FROM PRODUTO
   WHERE CDNVPRODUTO = '1';

   SELECT @V_DSAJUCTREC = MAX(SUBSTRING(DSAJUCTREC,1,20))
   FROM TIPOAJRECEBER
   WHERE @V_CDAJUSTPADR = CDAJUCTREC;

   IF @P_IDNFCOMPRA = 'N' BEGIN
      UPDATE  NOTAFISCAL
      SET CDFILIAPFATU = @P_CDFILIPROC,
          NRAPFATUTNF  = @P_NRAPURACFAT
      WHERE (CDEMPRESA    = @V_CDEMPRATAC) AND
            (CDFILIRECE   = @V_CDFILIAPUR) AND
            (DTENTRSAID BETWEEN  @P_DTINIAPUR AND @P_DTFINAPUR)    AND
            (IDENTRSAIDOP = 'E')          AND
            (IDSTATUS     <> 'C')         AND
            (ISNULL(IDSISTEMA,'DFE') IN ('DFE','EST')) AND
            ((NRAPFATUTNF IS NULL) OR (NRAPFATUTNF = @P_NRAPURACFAT));
   END;

   /*VERIFICA SE EXISTE REGISTRO NA TABELA NOVOCODIGO P/ A SRIE DO MRDP*/
   SELECT @V_PRXMRDP = CONVERT(NUMERIC,ISNULL(MAX(NRSEQUENCIAL),0))
   FROM NOVOCODIGO
   WHERE CDCONTADOR = 'LANCAMENTO DE MRDP';

   /*INCLUI CHAVE SEQUENCIAL PARA A SRIE DO MRDP*/
   IF (@V_PRXMRDP = 0) BEGIN
      INSERT INTO NOVOCODIGO
         (CDCONTADOR, NRSEQUENCIAL)
      VALUES
         ('LANCAMENTO DE MRDP', '00000000000000000001');

      SET @V_PRXMRDP = 1;
   END;

   /*BLOQUEIA REGISTRO DA SRIE DO MRDP NA TABELA NOVOCODIGO*/
   SELECT @V_PRXMRDP = CONVERT(NUMERIC, NRSEQUENCIAL) + 1
   FROM NOVOCODIGO
   WHERE CDCONTADOR = 'LANCAMENTO DE MRDP';

   /*INCLUSO DOS MRDP'S APURADOS CONSIDERANDO O NMERO MXIMO DE PRODUTOS MRDP*/
   DECLARE C_NOTAFISCAL CURSOR FOR
   SELECT N.NRINSJURNF, N.NRNOTAFISC, N.CDFILIAL, COUNT(*) AS NRITENSNOTA
   FROM NOTAFISCAL N, ITEMPRODUTO I
   WHERE N.CDFILIAL     = I.CDFILIAL    AND
         N.NRLANCTONF   = I.NRLANCTONF  AND
         N.CDFILIAPFATU = @P_CDFILIPROC    AND
         N.NRAPFATUTNF  = @P_NRAPURACFAT
   GROUP BY N.NRINSJURNF, N.NRNOTAFISC, N.CDFILIAL, N.NRLANCTONF

   OPEN C_NOTAFISCAL;
   FETCH NEXT FROM C_NOTAFISCAL INTO @V_NRINSJURNF, @V_NRLANCTONF, @V_CDFILIAL, @V_NRITENSNOTA

   WHILE (@@FETCH_STATUS = 0) BEGIN
      INSERT INTO MRDPAPUR
         (CDFILIAL, NRAPURACFAT, NRMRDPAPUR)
      VALUES
         (@P_CDFILIPROC, @P_NRAPURACFAT, RIGHT(REPLICATE('0', 7) + CONVERT(VARCHAR, @V_PRXMRDP), 7));

      SET @V_PRXMRDP = @V_PRXMRDP + 1;
      FETCH NEXT FROM C_NOTAFISCAL INTO @V_NRINSJURNF, @V_NRLANCTONF, @V_CDFILIAL, @V_NRITENSNOTA
   END;

   CLOSE C_NOTAFISCAL;
   DEALLOCATE C_NOTAFISCAL;

   /*ATUALIZAO DA TABELA NOVOCODIGO*/
   UPDATE NOVOCODIGO
   SET NRSEQUENCIAL = RIGHT(REPLICATE('0', 20) + CONVERT(VARCHAR, @V_PRXMRDP), 20)
   WHERE CDCONTADOR = 'LANCAMENTO DE MRDP';

   SELECT @V_SERIE = MAX(CDSERIE), @V_INSCESTA = MAX(CDINSCESTA), @V_INSCMUNI = MAX(CDINSCMUNI)
   FROM FILIAL F
   WHERE F.CDFILIAL  = @V_CDFILIAPUR   AND
         F.CDEMPRESA = @V_CDEMPRATAC;

   SELECT @V_CDSERIE = MAX(CDSERIE), @V_CDINSCATAC = MAX(CDINSCESTA), @V_CDINSCMUNI = MAX(CDINSCMUNI)
   FROM EMPRCNTRFIL F
   WHERE F.CDFILIAL  = @V_CDFILIAPUR   AND
         F.CDEMPRESA = @V_CDEMPRATAC;

   SELECT @V_CDSERIEDESP = MAX(CDSERIE)
   FROM EMPRCNTRFIL F
   WHERE F.CDFILIAL  = @V_CDFILIAPUR   AND
         F.CDEMPRESA = @V_CDEMPROPER;

   IF @V_CDSERIE IS NULL BEGIN
      SET @V_CDSERIE    = @V_SERIE;
      SET @V_CDINSCATAC = @V_INSCESTA;
      SET @V_CDINSCMUNI = @V_INSCMUNI;
   END;

   IF @V_CDSERIEDESP IS NULL BEGIN
      SET @V_CDSERIE  = @V_SERIE;
   END;


   /*VERIFICA A QTE MAXIMA DE PRODUTO POR SERIE*/
   SELECT @V_MAXITENSNF = ISNULL(MAX(NRMAXITNF),10)
   FROM SERIENF
   WHERE CDEMPRESA  = @V_CDEMPRATAC  AND
         CDINSCESTA = @V_CDINSCATAC  AND
         CDINSCMUNI = @V_CDINSCMUNI  AND
         CDSERIE    = @V_CDSERIE;


   SELECT @V_CDIMPOSTO = MAX(CDIMPOSTO)
   FROM IMPOSMRDP
   WHERE IDIMPOMRDP = 'P';

   IF @P_VRBASENFCMP <> 0 BEGIN

      SELECT @V_VRDESCNFCMP = ISNULL(SUM(VRBRUTITEM),0), @V_NUMITENS = COUNT(IP.CDPRODUTO)
      FROM  ITEMPRODUTO IP, NOTAFISCAL N,  TAXAADMFATUR TX,
            PRODUTO P,		 PRODUTO R
      WHERE N.CDFILIAPFATU     = @P_CDFILIPROC              AND
            N.NRAPFATUTNF      = @P_NRAPURACFAT             AND
            IP.CDFILIAL        = N.CDFILIAL                AND
            IP.NRLANCTONF      = N.NRLANCTONF              AND
            P.CDPRODUTO        = IP.CDPRODUTO              AND
            R.CDPRODUTO        = TX.CDPRODUTO              AND
            IP.CDFILIAL        = TX.CDFILIAL               AND
            (CHARINDEX(ISNULL(R.CDARVPROD,NULL), P.CDARVPROD) = 1);

      IF @V_VRDESCNFCMP <> 0 BEGIN
         SET @V_VRDESCNFCMP = ((@V_VRDESCNFCMP - @P_VRBASENFCMP) / @V_NUMITENS);
      END;
   END;

   DECLARE C_TAXA CURSOR FOR
   SELECT IP.CDFILIAL, IP.CDPRODUTO, VRBRUTITEM, R.CDARVPROD
   FROM  ITEMPRODUTO IP, NOTAFISCAL N,  TAXAADMFATUR TX,
   		PRODUTO P, PRODUTO R
   WHERE N.CDFILIAPFATU     = @P_CDFILIPROC              AND
         N.NRAPFATUTNF      = @P_NRAPURACFAT             AND
         IP.CDFILIAL        = N.CDFILIAL                AND
         IP.NRLANCTONF      = N.NRLANCTONF              AND
         N.CDTIPOOPER       <> '12'                     AND
         P.CDPRODUTO        = IP.CDPRODUTO              AND
         R.CDPRODUTO        = TX.CDPRODUTO              AND
         IP.CDFILIAL        = TX.CDFILIAL               AND
         (CHARINDEX(ISNULL(R.CDARVPROD,NULL), P.CDARVPROD) = 1)
   ORDER BY 2
   OPEN C_TAXA;
   FETCH NEXT FROM C_TAXA INTO @V_CDFILIAL, @V_CDPRODUTO, @V_VRBRUTITEM, @V_CDARVPROD

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SELECT @V_IDFATPRODCLI = MAX(IDFATPRODCLI)
      FROM PRODFILIFATU
      WHERE (CDFILIAL  = @V_CDFILIAL) AND
            (CHARINDEX(ISNULL(CDPRODUTO,NULL), @V_CDPRODUTO) = 1) AND
            (CDTPFATPRFIL  = '003');

      SET @V_VRBRUTITEM = (@V_VRBRUTITEM - @V_VRDESCNFCMP);

      SELECT @V_VRTXFATNIV = ISNULL(MAX(VRTAXADMFATU),0)
      FROM TAXAADMFATUR TX, PRODUTO P
      WHERE (TX.CDFILIAL  = @V_CDFILIAL) AND
            (TX.CDPRODUTO = P.CDPRODUTO)     AND
            (CHARINDEX(ISNULL(P.CDARVPROD,NULL), @V_CDARVPROD) = 1);

      IF @V_VRTXFATNIV <> 0 BEGIN
         SET @V_VRTAXAADM = ((@V_VRBRUTITEM) * (@V_VRTXFATNIV / 100));
      END
      ELSE BEGIN
          SET @V_VRTAXAADM = (@V_VRBRUTITEM * (@V_VRPCTXADM / 100));
      END;

      IF (@V_IDFATPRODCLI  = '1') OR (@V_IDFATPRODCLI IS NULL) BEGIN
         IF @V_IDCALCCOMPR = '1' BEGIN
            SET @V_VRLIQUFATU = @V_VRLIQUFATU  + ((@V_VRBRUTITEM + ISNULL(@V_VRTAXAADM,0)));
         END
         ELSE BEGIN
            SET @V_VRLIQUFATU =  @V_VRLIQUFATU + (ISNULL(@V_VRTAXAADM,0));
         END;
         SET @V_VRTOTCMPSTX = (@V_VRTOTCMPSTX + @V_VRBRUTITEM);
         SET @V_VRTOTCMPCTX = (@V_VRTOTCMPCTX + @V_VRTAXAADM);
      END
      ELSE IF (@V_IDFATPRODCLI  = '2') BEGIN
          /*V_VRLIQUFATU   := (V_VRLIQUFATU + V_VRBRUTITEM); */
          SET @V_VRTOTCMPSTX = (@V_VRTOTCMPSTX + @V_VRBRUTITEM);
      END;
      FETCH NEXT FROM C_TAXA INTO @V_CDFILIAL, @V_CDPRODUTO, @V_VRBRUTITEM, @V_CDARVPROD
   END;

   CLOSE C_TAXA;
   DEALLOCATE C_TAXA;

   SET @V_NRLANCTONF = @P_NRLANCTONF;
   SET @V_LANCAMENTO = @P_NRLANCTONF;

   DECLARE C_DELETANF CURSOR FOR
   SELECT CDFILIAL, NRLANCTONF
   FROM NOTAFISCAL
   WHERE CDFILIAL    = @P_CDFILIPROC    AND
         NRAPURACFAT = @P_NRAPURACFAT;

   OPEN C_DELETANF;
   FETCH NEXT FROM C_DELETANF INTO  @V_CDFILI, @V_NRLANCTO;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      EXEC DELETA_NF @V_CDFILI, @V_NRLANCTO;
      FETCH NEXT FROM C_DELETANF INTO @V_CDFILI, @V_NRLANCTO;
   END;

   CLOSE C_DELETANF;
   DEALLOCATE C_DELETANF;

   IF NOT (ISNULL(@V_IDNFPRODREV,'N') = 'S') BEGIN
      IF @V_VRLIQUFATU > 0 BEGIN
         IF @V_IDRECUIMPOS = 'S' BEGIN
            /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

            SELECT @V_IDENDCFOP = MAX(ISNULL(IDENDCFOPFIL,'I')),
                   @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
            FROM FILIAL
            WHERE (CDFILIAL = @P_CDFILIAPUR);

            IF @V_IDENDCFOP = 'I' BEGIN
               SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
               FROM INSCRESTAD
               WHERE CDEMPRESA  = @V_CDEMPRESA AND
                     CDINSCESTA = @V_CDINSCESTA;
            END
            ELSE BEGIN
               SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
               FROM ENDEFILI
               WHERE (CDFILIAL     = @P_CDFILIAPUR) AND
                     (IDTPENDEFILI = @V_IDENDCFOP);
            END;

            SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPCLI),'P'), @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI),'P')
            FROM CLIENTE
            WHERE (CDCLIENTE = @P_CDCLIENTE);

            SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO)
            FROM ENDECLIE
            WHERE (CDCLIENTE    = @P_CDCLIENTE) AND
                  (IDTPENDECLIE = @V_IDENDEMIS);

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            EXEC CONSULTA_GRUPOFISCAL 'C', @P_CDCLIENTE , @V_CDFILIAPUR, 'S', @V_CDTIPOOPER, @V_CDGRUPOFISC;

            /*CALCULO DA ALIQUOTA IMPOSTO*/

            /* ISS */

            EXEC CONSULTA_ALIQUOTA '31', 'S', @V_CDEMPRATAC, @V_CDPRGENEREV, @V_CDINSCATAC, @V_PAISORIG,
                                   @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DATAFIM,
                                   @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            /* PIS */

            EXEC CONSULTA_ALIQUOTA '50', 'S', @V_CDEMPRATAC, @V_CDPRGENEREV, @V_CDINSCATAC, @V_PAISORIG,
                                   @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DATAFIM,
                                   @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

             /* COFINS */

            EXEC CONSULTA_ALIQUOTA '60', 'S', @V_CDEMPRATAC, @V_CDPRGENEREV, @V_CDINSCATAC, @V_PAISORIG,
                                   @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DATAFIM,
                                   @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            IF @V_SOMAALQIMP <>  0 BEGIN
                IF @V_IDTAXAADM = 'D' BEGIN  /*POR DENTRO*/
                   SET @V_VRRECUIMCMP = (@V_SOMAALQIMP / 100);
                END
                ELSE BEGIN              /*POR FORA*/
                    SET @V_VRRECUIMCMP = (100 / (100 - @V_SOMAALQIMP));
                END;
            END;

            SET @V_VRLIQUFATU = (@V_VRLIQUFATU * @V_VRRECUIMCMP);

         END;

         /*INCLUSO DO CORPO DA NOTA */
         EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, @V_CDTIPOOPER,
                                    @V_CDSERIE, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                    @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                    @V_NRLANCTONF, NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                    @P_DATAFIM, NULL;

         /*INCLUSO DOS ITENS DA NOTA FISCAL*/
         EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRGENEREV,
                                      @V_CDPRGENEREV, @V_NMPRGENEREV, 1, @V_VRLIQUFATU, 0,
                                      NULL, NULL, NULL, NULL,
                                      NULL, NULL;

         /*EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS*/
         EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;

         SET @V_IDGEROUNF = 'S';

         SET @V_VRTOTACMP = @V_VRLIQUFATU;

      END;
   END
   ELSE BEGIN

      DECLARE C_ITEMNOTA CURSOR FOR
      SELECT I.CDPRODUTO,  PT.CDPRODESTO,
             (ISNULL(SUM(I.VRBRUTITEM),0)/ISNULL(SUM(QTITEMPROD),1))  AS VRBRUTITEM,
             ISNULL(SUM(QTITEMPROD),1) AS QTITEMPROD
      FROM NOTAFISCAL N, PRODUTO PT,
           PRODFILI P,   ITEMPRODUTO I
      WHERE N.CDFILIAL         = I.CDFILIAL                         AND
            N.NRLANCTONF       = I.NRLANCTONF                       AND
            ((N.CDFILIAPFATU   = @P_CDFILIPROC)                     OR
             (@P_CDFILIPROC IS NULL AND N.CDFILIAPFATU IS NULL))     AND
            ((N.NRAPFATUTNF    =  @P_NRAPURACFAT)                   OR
             (@P_NRAPURACFAT IS NULL AND N.NRAPFATUTNF IS NULL))     AND
            I.CDPRODUTO        = PT.CDPRODUTO                       AND
            PT.CDPRODESTO      = P.CDPRODUTO                        AND
            N.CDFILIAPFATU     = P.CDFILIAL                         AND
            (CHARINDEX(SUBSTRING(CDARVPROD,1, @V_CDNIVELPROD), @V_NVPRGENEREV) > 0)
      GROUP BY I.CDPRODUTO,   PT.CDPRODESTO;
      OPEN C_ITEMNOTA;
      FETCH NEXT FROM  C_ITEMNOTA INTO @V_CDPRODUTO, @V_CDPRODESTO, @V_VRBRUTITEM ;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_DESCIT     = 0;
         SET @V_SOMAALQIMP = 0;

         SELECT @V_VRTXADMPROD = MAX(P.VRTXADMPROD),
                @V_VRFATOCONV  = MAX(PT.VRFATOCONV),
                @V_NMPRODUTO   = MAX(NMPRODUTO)
         FROM NOTAFISCAL N, PRODUTO PT, PRODFILI P,
              ITEMPRODUTO I LEFT JOIN  ITEMPROIMPOS II ON
                                II.CDFILIAL     = I.CDFILIAL    AND
                                II.NRLANCTONF   = I.NRLANCTONF  AND
                                II.NRSEQITPROD  = I.NRSEQITPROD AND
                                II.CDIMPOSTO    = @V_CDIMPOSTO  AND
                                II.NRITPROIMPOS = '1'

         WHERE N.CDFILIAL         = I.CDFILIAL                        AND
               N.NRLANCTONF       = I.NRLANCTONF                      AND
               ((N.CDFILIAPFATU   = @P_CDFILIPROC)                    OR
                (@P_CDFILIPROC IS NULL AND N.CDFILIAPFATU IS NULL))   AND
               ((N.NRAPFATUTNF    =  @P_NRAPURACFAT)                  OR
                (@P_NRAPURACFAT IS NULL AND N.NRAPFATUTNF IS NULL))   AND
               I.CDPRODUTO        = PT.CDPRODUTO                      AND
               I.CDPRODUTO        = @V_CDPRODUTO                      AND
               PT.CDPRODESTO      = P.CDPRODUTO                       AND
               N.CDFILIAPFATU     = P.CDFILIAL
         GROUP BY P.VRTXADMPROD, PT.VRFATOCONV, NMPRODUTO;

         IF (@V_VRBRUTITEM > 0) BEGIN

            /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

            SELECT @V_IDENDCFOP  = MAX(ISNULL(IDENDCFOPFIL,'I')),
                   @V_CDEMPRESA  = MAX(CDEMPRESA),
                   @V_CDINSCESTA = MAX(CDINSCESTA)
            FROM FILIAL
            WHERE (CDFILIAL = @P_CDFILIAPUR);

            IF ( @V_IDENDCFOP = 'I') BEGIN
               SELECT @V_PAISORIG = MAX(CDPAIS),
                      @V_ESTAORIG = MAX(SGESTADO),
                      @V_MUNIORIG = MAX(CDMUNICIPIO)
               FROM INSCRESTAD
               WHERE CDEMPRESA  = @V_CDEMPRESA AND
                     CDINSCESTA = @V_CDINSCESTA;
            END
            ELSE BEGIN
               SELECT @V_PAISORIG = MAX(CDPAIS),
                      @V_ESTAORIG = MAX(SGESTADO),
                      @V_MUNIORIG = MAX(CDMUNICIPIO)
               FROM ENDEFILI
               WHERE (CDFILIAL     = @P_CDFILIAPUR) AND
                     (IDTPENDEFILI = @V_IDENDCFOP);
            END;

            SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPCLI),'P'),
                   @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI),'P')
            FROM CLIENTE
            WHERE (CDCLIENTE = @P_CDCLIENTE);

            SELECT @V_PAISDEST = MAX(CDPAIS),
                   @V_ESTADEST  = MAX(SGESTADO)
            FROM ENDECLIE
            WHERE (CDCLIENTE    = @P_CDCLIENTE) AND
                  (IDTPENDECLIE = @V_IDENDEMIS);

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF;

            EXEC CONSULTA_GRUPOFISCAL 'C', @P_CDCLIENTE , @V_CDFILIAPUR, 'S', '01', @V_CDGRUPOFISC;

             /*CALCULO DA ALIQUOTA IMPOSTO*/

            EXEC CONSULTA_ALIQUOTA '80', 'S',    @V_CDEMPRATAC,  @V_CDPRODUTO,  @V_CDINSCATAC, @V_PAISORIG,
                                    @V_ESTAORIG, @V_PAISDEST,    @V_ESTADEST,   @V_CDINSCMUNI, @V_VRBRUTITEM,
                                    @P_DATAFIM,  @P_CDFILIAPUR, @P_NRLANCTONF,  @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF);

            SET @V_SOMAALQIMP  = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF;

            EXEC CONSULTA_ALIQUOTA '50', 'S',   @V_CDEMPRATAC, @V_CDPRODUTO,  @V_CDINSCATAC, @V_PAISORIG,
                                    @V_ESTAORIG, @V_PAISDEST,   @V_ESTADEST,   @V_CDINSCMUNI, @V_VRBRUTITEM,
                                    @P_DATAFIM,  @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF);

            SET @V_SOMAALQIMP  = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF;

            EXEC CONSULTA_ALIQUOTA '60', 'S',   @V_CDEMPRATAC, @V_CDPRODUTO,  @V_CDINSCATAC, @V_PAISORIG,
                                   @V_ESTAORIG, @V_PAISDEST,   @V_ESTADEST,   @V_CDINSCMUNI, @V_VRBRUTITEM,
                                   @P_DATAFIM,  @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF);

            SET @V_SOMAALQIMP  = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF;

            SET @V_CDTIPOOPER  = '';

            DECLARE C_TIPOOPER CURSOR FOR
            SELECT N.CDTIPOOPER, N.CDFILIAL, N.NRLANCTONF
            FROM NOTAFISCAL N, ITEMPRODUTO I
            WHERE N.CDFILIAL         = I.CDFILIAL                          AND
                  N.NRLANCTONF       = I.NRLANCTONF                        AND
                  ((N.CDFILIAPFATU   = @P_CDFILIPROC)                      OR
                   (@P_CDFILIPROC IS NULL AND N.CDFILIAPFATU IS NULL))     AND
                  ((N.NRAPFATUTNF    =  @P_NRAPURACFAT)                    OR
                   (@P_NRAPURACFAT IS NULL AND N.NRAPFATUTNF IS NULL))     AND
                  I.CDPRODUTO        = @V_CDPRODUTO;

            OPEN C_TIPOOPER;
            FETCH NEXT FROM C_TIPOOPER INTO @V_CDTIPOOPER, @V_CDFILIAL, @V_NRLANCTOIT
            WHILE (@@FETCH_STATUS = 0) BEGIN
               IF @V_CDTIPOOPER = '02' BEGIN
                  SET @V_TIPOOPER = '02';
               END;

               SELECT @V_QTDESCIT = ISNULL(SUM(QTITEMPROD),0)
               FROM ITEMNOTAFISC IT, NOTAFISCAL T, ITEMPRODUTO IP
               WHERE (IT.CDFILIALIT   = @V_CDFILIAL)           AND
                     (IT.NRLANCTONFIT = @V_NRLANCTOIT)         AND
                     (T.CDFILIAL      = IT.CDFILIAL)           AND
                     (T.NRLANCTONF    = IT.NRLANCTONF)         AND
                     (IP.CDPRODUTO    = @V_CDPRODUTO)          AND
                     (IP.CDFILIAL     = T.CDFILIAL)            AND
                     (IP.NRLANCTONF   = T.NRLANCTONF)          AND
                     (IDSTATUS     <> 'C');

               SET @V_DESCIT  = @V_DESCIT + @V_QTDESCIT;

               SELECT @V_QTDESCIT1 = ISNULL(SUM(IP.QTITEMPROD),0)
               FROM NOTAFISCAL N, ITEMPRODUTO IP
               WHERE
                  (N.CDFILIEMIT   = @P_CDFILIAPUR) AND
                  (N.CDFILIAL     = IP.CDFILIAL)   AND
                  (N.NRLANCTONF   = IP.NRLANCTONF) AND
                  (IP.CDPRODUTO   = @V_CDPRODUTO)  AND
                  (N.IDSTATUS     <> 'C')          AND
                  (N.CDTIPOOPER   IN ('02','09'))  AND
                  (N.IDENTRSAIDOP = 'S')           AND
                  (N.DTENTRSAID BETWEEN @P_DATAINI AND @P_DATAFIM);

               SET @V_DESCIT = @V_DESCIT + @V_QTDESCIT1;

               FETCH NEXT FROM C_TIPOOPER INTO @V_CDTIPOOPER, @V_CDFILIAL, @V_NRLANCTOIT
            END;
            CLOSE C_TIPOOPER;
            DEALLOCATE C_TIPOOPER;

            IF (NOT @V_CDTIPOOPER = '02') BEGIN

                EXEC CONSULTA_ALIQUOTA '00', 'E',   @V_CDEMPRATAC, @V_CDPRODUTO,  @V_CDINSCATAC, @V_PAISORIG,
                                       @V_ESTAORIG, @V_PAISDEST,   @V_ESTADEST,   @V_CDINSCMUNI, @V_VRBRUTITEM,
                                       @P_DATAFIM,  @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

                SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
                FROM ALIQTEMP
                WHERE (NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF);

                SET @V_SOMAALQIMP  = @V_SOMAALQIMP + @V_VRALIQUTMP;

                DELETE ALIQTEMP
                WHERE NRALIQTEMP = @P_CDFILIAPUR + @P_NRLANCTONF;

            END;

            SELECT @V_VRCUSTOMED = TEKNISA.CUSTO_PROD (@P_CDFILIAPUR, @V_CDPRODESTO, 3, @P_DATAFIM, ' ', ' ',' ',' ')
            FROM PARAMGERAL;


            IF @V_IDRECUIMPOS = 'S' BEGIN
               IF @V_VRCUSTOMED > 0 BEGIN
                  SET @V_VRCUSTOMED = @V_VRFATOCONV * (@V_VRCUSTOMED/(1- (@V_SOMAALQIMP/100)));
               END
               ELSE BEGIN
                  SET @V_VRCUSTOMED = (@V_VRBRUTITEM/(1- (@V_SOMAALQIMP/100)));
               END;
            END;

            IF @V_GERANF = 'S' BEGIN
               /*INCLUSO DO CORPO DA NOTA*/
               EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, @V_CDTIPOOPER,
                                          @V_CDSERIE, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                          @V_LANCAMENTO, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                          @V_LANCAMENTO, NULL, NULL, NULL, NULL, NULL, NULL,
                                          NULL, NULL, NULL,   NULL, NULL, NULL, NULL,
                                          @P_DATAFIM, NULL;

               SET @V_GERANF = 'N';
            END;

            IF @V_IDTXADMPROD = 'S' BEGIN
               IF @V_IDTAXAADM = '1' BEGIN  /*POR DENTRO*/
                  SET @V_VRTAXAADM = (@V_VRCUSTOMED/ (1 - (@V_VRTXADMPROD / 100))) - @V_VRCUSTOMED;
               END
               ELSE BEGIN                      /*POR FORA*/
                  SET @V_VRTAXAADM = (@V_VRCUSTOMED * (@V_VRTXADMPROD/ 100));
               END;
            END
            ELSE BEGIN
               IF @V_IDTAXAADM = '1' BEGIN  /*POR DENTRO*/
                  SET @V_VRTAXAADM = (@V_VRCUSTOMED/ (1 - (@V_VRPCTXADM/ 100))) - @V_VRCUSTOMED;
               END
               ELSE BEGIN  /*POR FORA*/
                  SET @V_VRTAXAADM = (@V_VRCUSTOMED * (@V_VRPCTXADM/ 100));
               END;

            END;

            IF @V_IDCALCCOMPR = '1' BEGIN
               SET @V_VRLIQUFATU = (@V_VRCUSTOMED + ISNULL(@V_VRTAXAADM,0));
            END
            ELSE BEGIN
               SET @V_VRLIQUFATU = ISNULL(@V_VRTAXAADM,0) ;
            END;

            IF @V_MAXITENSNF > @V_NRITEM BEGIN
               /*INCLUSO DOS ITENS DA NOTA FISCAL*/
               SET @V_VRITEMNOTA = (@V_QTITEMPROD - @V_DESCIT);
               EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_LANCAMENTO, @V_CDPRODUTO,
                                            @V_CDPRODUTO, @V_NMPRODUTO, @V_VRITEMNOTA, @V_VRLIQUFATU, 0,
                                             NULL, NULL, NULL, NULL,
                                            NULL, NULL;

               /*EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS*/
                EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_LANCAMENTO;

                SET @V_VRTOTACMP = @V_VRTOTACMP + ((@V_QTITEMPROD - @V_DESCIT) *  @V_VRLIQUFATU);
                SET @V_NRITEM = @V_NRITEM + 1;
            END
            ELSE BEGIN

               SET @V_LANCNFILIAL = 'LANCNF/FILIAL' + @P_CDFILIAPUR;
               
               EXEC NOVO_CODIGO @V_LANCNFILIAL,@V_LANCAMENTO;
               SET @V_LANCAMENTO = SUBSTRING(@V_LANCAMENTO,11,10);

               EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, @V_CDTIPOOPER,
                                          @V_CDSERIE, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                          @V_LANCAMENTO, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                          @V_LANCAMENTO,NULL, NULL, NULL, NULL, NULL, NULL,
                                          NULL, NULL,  NULL,  NULL, NULL, NULL, NULL,
                                          @P_DATAFIM, NULL;


               /*INCLUSO DOS ITENS DA NOTA FISCAL*/
               SET @V_VRITEMNOTA = (@V_QTITEMPROD - @V_DESCIT);
               EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_LANCAMENTO, @V_CDPRODUTO,
                                            @V_CDPRODUTO, @V_NMPRODUTO, @V_VRITEMNOTA, @V_VRLIQUFATU, 0,
                                            NULL, NULL, NULL, NULL,
                                            NULL, NULL;

               /*EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS*/
               EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_LANCAMENTO;
               SET @V_VRTOTACMP = @V_VRTOTACMP + ((@V_QTITEMPROD - @V_DESCIT) *  @V_VRLIQUFATU);
               SET @V_NRITEM = 0;
            END;
         END;
         FETCH NEXT FROM  C_ITEMNOTA INTO @V_CDPRODUTO, @V_CDPRODESTO, @V_VRBRUTITEM;
      END;
      CLOSE C_ITEMNOTA;
      DEALLOCATE C_ITEMNOTA;
   END;

   /*INCLUSO DO ITENS DA DESPESA ADMINISTRATIVAS LANADAS NO FAI*/
   SET @V_VERIGRUPDES = 'X';

   IF @V_NMPRESTSERV IS NULL BEGIN
      DECLARE C_DESPADMFATUR CURSOR FOR
      SELECT L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT,  L.VRLANCDESFAT,
             D.CDGRUPOFATUR, D.CDPRODUTO, D.DSDESPADMFAT, ISNULL(L.VRTXLANCDESP,0) VRTAXADMFATU
      FROM LANCDESPFATU L,  DESPADMFATUR D
      WHERE (L.CDFILIAL = @P_CDFILIAPUR)                            AND
            (D.CDDESPADMFAT = L.CDDESPADMFAT)                      AND
            (L.DTLANCDESFAT BETWEEN @P_DATAINI AND @P_DATAFIM)
      GROUP BY D.CDGRUPOFATUR, L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT, L.VRLANCDESFAT,
               D.CDPRODUTO, D.DSDESPADMFAT, VRTXLANCDESP

      OPEN C_DESPADMFATUR;
      FETCH NEXT FROM C_DESPADMFATUR INTO @CDFILIAL, @CDDESPADMFAT, @DTLANCDESFAT, @VRLANCDESFAT,
                                          @CDGRUPOFATUR, @CDPRODUTO, @DSDESPADMFAT, @VRTAXADMFATU

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (LTRIM(@V_CDFILIAPUR) IS NULL) BEGIN
            INSERT INTO CTRLAPURFAT
               (CDFILIAL, NRAPURACFAT,  CDFILIAPUR, CDCLIENTE, DTINIAPURAC, DTFIMAPURAC, CDTIPOFATUCT)
            VALUES
               (@P_CDFILIPROC, @P_NRAPURACFAT, @P_CDFILIAPUR, @P_CDCLIENTE, @P_DATAINI, @P_DATAFIM, '003');
         END;

         IF @V_VERIGRUPDES <> @CDGRUPOFATUR BEGIN

            IF (@V_VERIGRUPDES <> 'X' AND @V_VRTOTADESP > 0) BEGIN
              /*EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS*/
              EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
            END;

            IF @V_IDCONCMPDES = 'S'  BEGIN

               SET @V_NRLANCTONF = RIGHT(REPLICATE('0', 10) + CONVERT(VARCHAR, CONVERT(NUMERIC, (@V_NRLANCTONF) + 1)), 10);

               SET @V_CDSERIEDESP = ISNULL(@V_CDSERIEDESP,@V_CDSERIE);

               /*INCLUSO DO CORPO DA NOTA */
               EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @P_CDFILIAPUR, V_CDEMPROPER, V_CDTIPOOPER,
                                          @V_CDSERIEDESP, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                          @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                          @V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                                          NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                          @P_DATAFIM, NULL;

            END;
         END;

         SET @V_VERIGRUPDES = @CDGRUPOFATUR;

         SET @V_VRTOTDESSTX = (@V_VRTOTDESSTX + @VRLANCDESFAT);

         IF @VRTAXADMFATU <> 0  BEGIN
            SET @V_VRTAXAADM = (@VRLANCDESFAT * (@VRTAXADMFATU / 100));
         END
         ELSE BEGIN
            SET @V_VRTAXAADM = (@VRLANCDESFAT * (@V_VRPERCDESP / 100));
         END;

         SELECT @V_IDFATPRODCLI = MAX(IDFATPRODCLI)
         FROM PRODFILIFATU
         WHERE (CDFILIAL  = @CDFILIAL) AND
               (CHARINDEX(ISNULL(CDPRODUTO,NULL), @CDPRODUTO) = 1)  AND
               (CDTPFATPRFIL  = '003');

         IF (@V_IDFATPRODCLI  = '1') OR (@V_IDFATPRODCLI IS NULL) BEGIN
            SET @V_VRLIQUFATU  = (@VRLANCDESFAT + ISNULL(@V_VRTAXAADM,0));
            SET @V_VRTOTDESCTX = (@V_VRTOTDESCTX + ISNULL(@V_VRTAXAADM,0));
         END
         ELSE IF (@V_IDFATPRODCLI  = '2') BEGIN
            SET @V_VRLIQUFATU  = @VRLANCDESFAT;
         END;

         IF @V_IDRECUIMPOS = 'S' BEGIN

            SET @V_SOMAALQIMP = 0;

            IF @V_IDGEROUNF = 'S' BEGIN

               /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

               SELECT @V_IDENDCFOP = MAX(ISNULL(IDENDCFOPFIL,'I')),
                      @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
               FROM FILIAL
               WHERE (CDFILIAL = @P_CDFILIAPUR);

               IF @V_IDENDCFOP = 'I' BEGIN
                  SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
                  FROM INSCRESTAD
                  WHERE CDEMPRESA  = @V_CDEMPRESA AND
                        CDINSCESTA = @V_CDINSCESTA;
               END
               ELSE BEGIN
                  SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
                  FROM ENDEFILI
                  WHERE (CDFILIAL     = @P_CDFILIAPUR) AND
                        (IDTPENDEFILI = @V_IDENDCFOP);
               END;

               SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPCLI),'P'), @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI),'P')
               FROM CLIENTE
               WHERE (CDCLIENTE = @P_CDCLIENTE);

               SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO)
               FROM ENDECLIE
               WHERE (CDCLIENTE    = @P_CDCLIENTE) AND
                     (IDTPENDECLIE = @V_IDENDEMIS);

            END;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            EXEC CONSULTA_GRUPOFISCAL 'C', @P_CDCLIENTE , @V_CDFILIAPUR, 'S', @V_CDTIPOOPER, @V_CDGRUPOFISC;

            /*CALCULO DA ALIQUOTA IMPOSTO*/

            /* ISS */

            EXEC CONSULTA_ALIQUOTA '31', 'S',  @V_CDEMPRATAC, @CDPRODUTO,  @V_CDINSCATAC, @V_PAISORIG,
                                   @V_ESTAORIG,  @V_PAISDEST,  @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DATAFIM,
                                   @P_CDFILIAPUR, @P_NRLANCTONF,  @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP  = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            /* PIS */

            EXEC CONSULTA_ALIQUOTA'50', 'S',  @V_CDEMPRATAC, @CDPRODUTO,  @V_CDINSCATAC, @V_PAISORIG,
                                  @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DATAFIM,
                                  @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            /* COFINS */

            EXEC CONSULTA_ALIQUOTA '60', 'S', @V_CDEMPRATAC, @CDPRODUTO, @V_CDINSCATAC, @V_PAISORIG,
                                   @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DATAFIM,
                                   @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP  = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            IF @V_SOMAALQIMP <>  0 BEGIN
               IF @V_IDTAXAADM = 'D' BEGIN  /*POR DENTRO*/
                  SET @V_VRRECUIMDES = (@V_SOMAALQIMP / 100);
               END
               ELSE BEGIN                      /*POR FORA*/
                  SET @V_VRRECUIMDES = (100 / (100 - @V_SOMAALQIMP));
               END;
            END;
            SET @V_VRLIQUFATU = (@V_VRLIQUFATU * @V_VRRECUIMDES);
         END;

         /*INCLUSO DOS ITENS DA NOTA FISCAL*/
         IF @V_VRLIQUFATU > 0 BEGIN
            EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @CDPRODUTO,
                                         @CDDESPADMFAT, @DSDESPADMFAT, 1, @V_VRLIQUFATU, 0,
                                         NULL, NULL, NULL, NULL,
                                         NULL, NULL;

            UPDATE LANCDESPFATU
            SET CDFILILANC = @P_CDFILIPROC,
                NRLANCTONF = @V_NRLANCTONF
            WHERE (CDFILIAL = @P_CDFILIAPUR) AND
                  (CDDESPADMFAT = @CDDESPADMFAT) AND
                  (DTLANCDESFAT BETWEEN @P_DATAINI AND @P_DATAFIM);

            SET @V_VRTOTADESP = (@V_VRTOTADESP + @V_VRLIQUFATU);
         END;
         FETCH NEXT FROM C_DESPADMFATUR INTO @CDFILIAL, @CDDESPADMFAT, @DTLANCDESFAT, @VRLANCDESFAT,
                                             @CDGRUPOFATUR, @CDPRODUTO, @DSDESPADMFAT, @VRTAXADMFATU
      END;
      CLOSE C_DESPADMFATUR;
      DEALLOCATE C_DESPADMFATUR;

      IF @V_VERIGRUPDES  <> 'X' AND @V_VRTOTADESP > 0 BEGIN
         EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
      END;
   END
   ELSE BEGIN
      IF @V_IDCONCMPDES = 'S' BEGIN
         IF (LTRIM(@V_CDFILIAPUR) IS NULL) BEGIN
            INSERT INTO CTRLAPURFAT
               (CDFILIAL, NRAPURACFAT,  CDFILIAPUR, CDCLIENTE, DTINIAPURAC, DTFIMAPURAC, CDTIPOFATUCT)
            VALUES
               (@P_CDFILIPROC, @P_NRAPURACFAT, @P_CDFILIAPUR, @P_CDCLIENTE, @P_DATAINI, @P_DATAFIM, '003');
         END;

         SET @V_NRLANCTONF = RIGHT(REPLICATE('0', 10) + CONVERT(VARCHAR, CONVERT(NUMERIC, (@V_NRLANCTONF) + 1)), 10);

         /*INCLUSO DO CORPO DA NOTA */
         EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @P_CDFILIAPUR, @V_CDEMPROPER, @V_CDTIPOOPER,
                                    @V_CDSERIEDESP, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                    @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                    @V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                    @P_DATAPROC, NULL;

         IF @V_IDTAXAADM = 'D' BEGIN  /*POR DENTRO*/
            SET @V_VRTAXAADM = (@V_VRTOTACMP / (1 - (@V_VRPERCDESP / 100))) - (@V_VRTOTACMP);
         END
         ELSE  BEGIN  /*POR FORA*/
            SET @V_VRTAXAADM = (@V_VRTOTACMP * (@V_VRPERCDESP / 100));
         END;

         SET @V_VRLIQUFATU = ISNULL(@V_VRTAXAADM,0);

         EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRESTSERV, @V_CDPRESTSERV, @V_NMPRESTSERV,
                                      1, @V_VRLIQUFATU, 0, NULL, NULL, NULL, NULL, NULL, NULL;

         EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
      END;
   END;

   IF (NOT @V_IDNFPRODREV = 'S') AND (@V_IDGEROUNF = 'S')  BEGIN
      /* Gerao do Aviso de Dbito */

      SET @V_VRSALDODOT = 0;

      IF @V_IDPERCDOTA1 = 'S' BEGIN
         SET @V_VRSALDODOT = @V_VRSALDODOT + ((@V_VRTOTCMPSTX + @V_VRTOTACMP + @V_VRTOTADESP) * (@V_VRPERCDOT1 / 100));
      END;

      IF @V_IDPERCDOTA2 = 'S' BEGIN
         SET @V_VRSALDODOT = @V_VRSALDODOT + ((@V_VRTOTDESSTX * (@V_VRPERCDOT2 / 100)) + ((@V_VRTOTDESCTX + @V_VRTOTCMPCTX) * (@V_VRPERCDOT2 / 100)));
      END;

      IF @V_IDPERCDOTA3 = 'S' BEGIN
          SET @V_VRSALDODOT = @V_VRSALDODOT + ((@V_VRTOTDESSTX + (@V_VRTOTDESCTX + @V_VRTOTCMPCTX)) * (@V_VRPERCDOT3 / 100));
      END;

      IF @V_IDPERCDOTA4 = 'S' BEGIN
         SET @V_VRSALDODOT = @V_VRSALDODOT + ((@V_VRTOTCMPSTX + @V_VRTOTACMP) * (@V_VRPERCDOT4 / 100));
      END;

      IF @V_IDPERCDOTA5 = 'S' BEGIN
         SET @V_VRSALDODOT = @V_VRSALDODOT + ((@V_VRTOTDESSTX + @V_VRTOTDESCTX) + ((@V_VRTOTDESSTX + @V_VRTOTDESCTX)* (@V_VRRECUIMDES - 1)))  * (@V_VRPERCDOT5 / 100);
      END;

      IF @V_IDPERCDOTA6 = 'S' BEGIN
         SET @V_VRSALDODOT = @V_VRSALDODOT + (@V_VRPERCDOT6 / 100);
      END;

      SET @V_VRSALDODOT = (@V_VRSALDODOT - @P_VRNOTACRED);

      IF @V_VRSALDODOT > 0 BEGIN

         SET @V_NRLANCTONF = RIGHT(REPLICATE('0', 10) + CONVERT(VARCHAR, CONVERT(NUMERIC, (@V_NRLANCTONF) + 1)), 10);

         EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, '12',
                                    @V_CDSERIEDOT, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                    @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                    @V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                    @P_DATAFIM, NULL;


         SELECT @V_NMPRGENEREV = MAX(DSITEMISSAO)
         FROM ITEMISSAO
         WHERE CDPRODUTO = @V_CDPRODDOTA;

         SET @V_VRSALDODOT = ROUND(@V_VRSALDODOT, 2);

         EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRODDOTA,
                                      @V_CDPRODDOTA, @V_NMPRGENEREV, 1, @V_VRSALDODOT,
                                      0, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                      NULL, NULL,  NULL,  'S' , '4';

         EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
      END;

      /* Gerao do Reembolso de Compras */

      IF (@V_VRTOTCMPSTX > 0) AND (@V_CDPROREECMP IS NOT NULL) BEGIN

            SET @V_NRLANCTONF = RIGHT(REPLICATE('0', 10) + CONVERT(VARCHAR, CONVERT(NUMERIC, (@V_NRLANCTONF) + 1)), 10);

            EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, '12',
                                       @V_CDSERIEDOT, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                       @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                       @V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                                       NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                       @P_DATAFIM, NULL;

            SELECT @V_NMPRGENEREV = MAX(DSITEMISSAO)
            FROM ITEMISSAO
            WHERE CDPRODUTO = @V_CDPROREECMP;

            SET @V_VRTOTCMPSTX = ROUND(@V_VRTOTCMPSTX,2);

            EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPROREECMP,
                                         @V_CDPROREECMP, @V_NMPRGENEREV, 1, @V_VRTOTCMPSTX, 0,
                                         NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                         NULL,  'S', '3' ;

            EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;

            IF (@V_VRTOTCMPSTX > @V_VRSALDODOT)  AND (@V_VRSALDODOT <> 0) AND
               (@V_CDAJUSTPADR IS NOT NULL)  BEGIN

               SELECT @V_NRSEQVENREC = MAX(NRSEQVENREC), @V_NRPARCELAREC = MAX(NRPARCELAREC), @V_VRATUAREC = ISNULL(SUM(VRATUAREC),0)
               FROM CONTARECEBER
               WHERE (CDFILIAL    =  @P_CDFILIPROC)  AND
                     (NRLANCTONF  =  @V_NRLANCTONF);

               IF @V_VRATUAREC > (ROUND(@V_VRSALDODOT,2)) BEGIN

                  SET @V_VRSALDODOT = ROUND(@V_VRSALDODOT,2);
                  INSERT INTO AJCTRECEBER
                  (CDFILIAL,   NRLANCTONF,  DTAJUSTEREC, CDAJUCTREC, DSAJUSTEREC,
                   VRAJUSTEREC, NRSEQVENREC, NRPARCELAREC)
                  VALUES
                  (@P_CDFILIPROC, @V_NRLANCTONF, GETDATE(),  @V_CDAJUSTPADR, @V_DSAJUCTREC,
                   @V_VRSALDODOT, @V_NRSEQVENREC, @V_NRPARCELAREC);

               END;
            END;
      END;
      /* Gerao do Crdito em Relao a Dotao da Apurao Passada */

      SELECT @V_VRDOTPURPASS = ISNULL(SUM(VRBRUTITEM),0)
      FROM NOTAFISCAL N, ITEMPRODUTO IP
      WHERE  (N.CDFILIEMIT   = @P_CDFILIAPUR)  AND
             (N.IDSTATUS     <> 'C')          AND
             (N.CDTIPOOPER   = '12')          AND
             (N.IDENTRSAIDOP = 'S')           AND
             (N.DTENTRSAID BETWEEN @V_DTINIAPURAC  AND @V_DTFIMAPURAC) AND
             (IP.CDFILIAL    = N.CDFILIAL)                           AND
             (IP.NRLANCTONF  = N.NRLANCTONF)                         AND
             (IP.IDTPNFCREDEB   = '4');

      IF @V_VRDOTPURPASS > 0 BEGIN

         SET @V_NRLANCTONF = RIGHT(REPLICATE('0', 10) + CONVERT(VARCHAR, CONVERT(NUMERIC, (@V_NRLANCTONF) + 1)), 10);

         EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, '12',
                                    @V_CDSERIEDOT, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                    @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                    @V_NRLANCTONF,NULL, NULL, NULL, NULL, NULL, NULL,
                                    NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                    @P_DATAFIM, NULL;


         SELECT @V_NMPRGENEREV = MAX(DSITEMISSAO)
         FROM ITEMISSAO
         WHERE CDPRODUTO = @V_CDPRODCREDI;

         EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRODCREDI,
                                      @V_CDPRODCREDI, @V_NMPRGENEREV, 1, @V_VRDOTPURPASS, 0,
                                      NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                      NULL, NULL,  NULL,  'S', '2';

         EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;


         SET @V_VRSALDODEV = @V_VRDOTPURPASS - (@V_VRTOTACMP + @V_VRTOTADESP + @V_VRTOTCMPSTX);

         IF @V_VRSALDODEV > 0 BEGIN

            /* Gerao de Nota Crdito ou  Aviso de Crdito */
            SET @V_NRLANCTONF = RIGHT(REPLICATE('0', 10) + CONVERT(VARCHAR, CONVERT(NUMERIC, (@V_NRLANCTONF) + 1)), 10);

            IF @V_IDAVISOCRED = 'C' BEGIN
               EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, '12',
                                          '', '', @P_DATAFIM, 'FAI',
                                          @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                          @V_NRLANCTONF, NULL, NULL, NULL, NULL, NULL, NULL,
                                          NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                          NULL, @V_IDAVISOCRED;  /* esse documento devera aparecer
                                                                    somente na apuraao do mandato*/
            END
            ELSE BEGIN

               EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, '12',
                                          @V_CDSERIEDOT, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                          @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                          @V_NRLANCTONF, NULL, NULL, NULL, NULL, NULL, NULL,
                                          NULL, NULL, NULL, NULL,  NULL, NULL, NULL,
                                          @P_DATAFIM, @V_IDAVISOCRED;

            END;


            SELECT @V_NMPRGENEREV = DSITEMISSAO
            FROM ITEMISSAO
            WHERE CDPRODUTO =  @V_CDPRODCREDI;

            SET @V_VRSALDODEV = ROUND(@V_VRSALDODEV,2);

            EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRODCREDI,
                                         @V_CDPRODCREDI, @V_NMPRGENEREV, 1, @V_VRSALDODEV, 0,
                                         NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                         NULL, NULL,  NULL,  'S' , '2';

            EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
         END
         ELSE IF @V_VRSALDODEV = 0 BEGIN

            /* Aviso de  Debito/Crdito */
            SET @V_NRLANCTONF = RIGHT(REPLICATE('0', 10) + CONVERT(VARCHAR, CONVERT(NUMERIC, (@V_NRLANCTONF) + 1)), 10);

            EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, '12',
                                       @V_CDSERIEDOT, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                       @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                       @V_NRLANCTONF, NULL, NULL, NULL, NULL, NULL, NULL,
                                       NULL, NULL, NULL, NULL,  NULL, NULL, @P_DATAFIM,
                                       NULL;

            SELECT V_NMPRGENEREV = DSITEMISSAO
            FROM ITEMISSAO
            WHERE CDPRODUTO = @V_CDPRODCREDI;

            SET @V_TOTAL = ROUND(@V_VRTOTACMP + @V_VRTOTADESP,2);

            EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRODCREDI,
                                         @V_CDPRODCREDI, @V_NMPRGENEREV, 1, @V_TOTAL, 0,
                                         NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                        NULL, NULL,  NULL,  'S' , '2';

            SELECT @V_NMPRGENEREV = DSITEMISSAO
            FROM ITEMISSAO
            WHERE CDPRODUTO = @V_CDPRODDOTA;

            SET @V_VRDOTPURPASS = ROUND(@V_VRDOTPURPASS,2);

            EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRODDOTA,
                                         @V_CDPRODDOTA, @V_NMPRGENEREV, 1, @V_VRDOTPURPASS, 0,
                                         NULL, NULL, NULL, NULL, NULL, NULL, NULL,
                                         NULL, NULL,  NULL,  'S' , '1';

            EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
         END;
      END;
   END;
END
;

